import java.io.*;
import java.net.*;
import java.util.*;

class Server implements NetworkConstants{

	HashMap clients = new HashMap();

	public static void main(String [] args){
		new Server().go();
	}

	public void go(){
		try{
			ServerSocket serverSocket = new ServerSocket(PORT);
			while(true){
				System.out.println("Server is listening ... ");
				Socket socket = serverSocket.accept();
				new ClientThread(socket).start();
			}
		}catch(IOException e){
			System.err.println(e);
			System.exit(1);
		}
	}


	class ClientThread extends Thread{
		ObjectInputStream oin;
		ObjectOutputStream oout;

		ClientThread(Socket socket){
			System.out.println("Starting new ClientThread from socket: " + socket);
			try{

				oout = new ObjectOutputStream(
						//new BufferedOutputStream(
							socket.getOutputStream());

				oin = new ObjectInputStream(
						//new BufferedInputStream(
							socket.getInputStream());


				Message init = (Message)oin.readObject();
				System.out.println("Got from client " + init);
				if(init.destination != Message.CONNECT)
					throw new Exception("Not a connect message");
				if(clients.containsKey(new Integer(init.myNumber))){
					oout.writeObject(new Message(Message.BAD_NUMBER));
					return;
				}
				//if here than number is ok
				clients.add(new Integer(init.myNumber), ClientThread);

			}catch(Exception e){
				System.err.println("In thread " + this + " : " +e);
			}
		}

		public void run(){
			while(true){



			}
		}
	}
}